## net.sf.saxon.dom
Class DOMEmitter

    java.lang.Object
      |
      +--net.sf.saxon.event.Emitter
            |
            +--net.sf.saxon.dom.DOMEmitter

All Implemented Interfaces:
  Receiver, javax.xml.transform.Result

public class DOMEmitter
extends Emitter

DOMEmitter is an Emitter that attaches the result tree to a specified Node in a DOM Document

Field Summary
`protected org.w3c.dom.Node` `currentNode`
`protected org.w3c.dom.Document` `document`

Fields inherited from class net.sf.saxon.event.Emitter
`characterSet, config, namePool, outputProperties, outputStream, streamResult, systemId, writer`

Fields inherited from interface javax.xml.transform.Result
`PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

Constructor Summary
`DOMEmitter()`

Method Summary
`void` `attribute(int nameCode, int typeCode, java.lang.CharSequence value, int locationId, int properties)` Notify an attribute.
`void` `characters(java.lang.CharSequence chars, int locationId, int properties)` Character data.
`void` `close()` End of the document.
`void` `comment(java.lang.CharSequence chars, int locationId, int properties)` Handle a comment.
`void` `endDocument()` Notify the end of a document node
`void` `endElement()` End of an element.
`void` `namespace(int namespaceCode, int properties)` Notify a namespace.
`void` `open()` Start of the document.
`void` `processingInstruction(java.lang.String target, java.lang.CharSequence data, int locationId, int properties)` Handle a processing instruction.
`void` `setNode(org.w3c.dom.Node node)` Set output destination
`void` `startContent()` Notify the start of the content, that is, the completion of all attributes and namespaces.
`void` `startDocument(int properties)` Start of a document node.
`void` `startElement(int nameCode, int typeCode, int locationId, int properties)` Start of an element.

Methods inherited from class net.sf.saxon.event.Emitter
`getConfiguration, getDocumentLocator, getOutputProperties, getOutputStream, getSystemId, getWriter, makeEmitter, makeWriter, setConfiguration, setDocumentLocator, setOutputProperties, setOutputStream, setStreamResult, setSystemId, setUnparsedEntity, setWriter, usesWriter`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### currentNode

    protected org.w3c.dom.Node currentNode

### document

    protected org.w3c.dom.Document document

Constructor Detail

### DOMEmitter

    public DOMEmitter()

Method Detail

### open

    public void open()

  Start of the document.

### close

    public void close()

  End of the document.

### startDocument

    public void startDocument(int properties)
                       throws XPathException

  Start of a document node.

    `XPathException`

### endDocument

    public void endDocument()
                     throws XPathException

  Notify the end of a document node

    `XPathException`

### startElement

    public void startElement(int nameCode,
                             int typeCode,
                             int locationId,
                             int properties)
                      throws XPathException

  Start of an element.

  Parameters:
    `nameCode` - integer code identifying the name of the element within the name pool.
    `typeCode` - integer code identifying the element's type within the name pool. The value -1 indicates the default type, xdt:untyped.
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `XPathException`

### namespace

    public void namespace(int namespaceCode,
                          int properties)
                   throws XPathException

  Description copied from interface: `Receiver`
  Notify a namespace. Namespaces are notified after the startElement event, and before any children for the element. The namespaces that are reported are only required to include those that are different from the parent element; however, duplicates may be reported. A namespace must not conflict with any namespaces already used for element or attribute names.

  Parameters:
    `namespaceCode` - an integer: the top half is a prefix code, the bottom half a URI code. These may be translated into an actual prefix and URI using the name pool. A prefix code of zero represents the empty prefix (that is, the default namespace). A URI code of zero represents a URI of "", that is, a namespace undeclaration.
    `XPathException`

### attribute

    public void attribute(int nameCode,
                          int typeCode,
                          java.lang.CharSequence value,
                          int locationId,
                          int properties)
                   throws XPathException

  Description copied from interface: `Receiver`
  Notify an attribute. Attributes are notified after the startElement event, and before any children. Namespaces and attributes may be intermingled.

  Parameters:
    `nameCode` - The name of the attribute, as held in the name pool
    `typeCode` - The type of the attribute, as held in the name pool
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this attribute
  NO_SPECIAL_CHARACTERS
    Attribute value contains no special characters
    `XPathException`

### startContent

    public void startContent()
                      throws XPathException

  Description copied from interface: `Receiver`
  Notify the start of the content, that is, the completion of all attributes and namespaces. Note that the initial receiver of output from XSLT instructions will not receive this event, it has to detect it itself. Note that this event is reported for every element even if it has no attributes, no namespaces, and no content.

    `XPathException`

### endElement

    public void endElement()
                    throws XPathException

  End of an element.

    `XPathException`

### characters

    public void characters(java.lang.CharSequence chars,
                           int locationId,
                           int properties)
                    throws XPathException

  Character data.

  Parameters:
    `chars` - The characters
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this text node
  USE_CDATA
    Output as a CDATA section
  NO_SPECIAL_CHARACTERS
    Value contains no special characters
  WHITESPACE
    Text is all whitespace
    `XPathException`

### processingInstruction

    public void processingInstruction(java.lang.String target,
                                      java.lang.CharSequence data,
                                      int locationId,
                                      int properties)
                               throws XPathException

  Handle a processing instruction.

  Parameters:
    `target` - The PI name. This must be a legal name (it will not be checked).
    `data` - The data portion of the processing instruction
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the PI. The following bits are defined:
  CHECKED
    Data is known to be legal (e.g. doesn't contain "?>")
    `XPathException`

### comment

    public void comment(java.lang.CharSequence chars,
                        int locationId,
                        int properties)
                 throws XPathException

  Handle a comment.

  Parameters:
    `chars` - The content of the comment
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the comment. The following bits are defined:
  CHECKED
    Comment is known to be legal (e.g. doesn't contain "--")
    `XPathException`

### setNode

    public void setNode(org.w3c.dom.Node node)

  Set output destination